---
title: 'CSP: plugin-types'
slug: Web/HTTP/Headers/Content-Security-Policy/plugin-types
tags:
  - CSP
  - Content-Security-Policy
  - Directive
  - Flash
  - HTTP
  - Java
  - Plugin
  - Plugins
  - Security
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>plugin-types</strong></code> directive restricts the set of plugins that can be embedded into a document by limiting the types of resources which can be loaded.</p>

<p>Instantiation of an {{HTMLElement("embed")}}, {{HTMLElement("object")}} or {{HTMLElement("applet")}} element will fail if:</p>

<ul>
 <li>the element to load does not declare a valid MIME type,</li>
 <li>the declared type does not match one of specified types in the <code>plugin-types</code> directive,</li>
 <li>the fetched resource does not match the declared type.</li>
</ul>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">CSP version</th>
   <td>2</td>
  </tr>
  <tr>
   <th scope="row">Directive type</th>
   <td>{{Glossary("Document directive")}}</td>
  </tr>
  <tr>
   <th scope="row">{{CSP("default-src")}} fallback</th>
   <td>No. Not setting this allows anything.</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>One or more <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">MIME types</a> can be set for the <code>plugin-types</code> policy:</p>

<pre class="syntaxbox">Content-Security-Policy: plugin-types &lt;type&gt;/&lt;subtype&gt;;
Content-Security-Policy: plugin-types &lt;type&gt;/&lt;subtype&gt; &lt;type&gt;/&lt;subtype&gt;;
</pre>

<dl>
 <dt>&lt;type&gt;/&lt;subtype&gt;</dt>
 <dd>A valid <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types/Complete_list_of_MIME_types">MIME type</a>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Disallowing_plugins">Disallowing plugins</h3>

<p>To disallow all plugins, the {{CSP("object-src")}} directive should be set to <code>'none'</code> which will disallow plugins. The <code>plugin-types</code> directive is only used if you are allowing plugins with <code>object-src</code> at all.</p>

<pre class="brush: html">&lt;meta http-equiv="Content-Security-Policy" content="object-src 'none'"&gt;</pre>

<h3 id="Allowing_Flash_content">Allowing Flash content</h3>

<p>The content security policy</p>

<pre class="brush: bash">Content-Security-Policy: plugin-types application/x-shockwave-flash</pre>

<p>will allow to load flash objects:</p>

<pre class="brush: html">&lt;object data="https://example.com/flash" type="application/x-shockwave-flash"&gt;&lt;/object&gt;</pre>

<h3 id="Allowing_Java_applets">Allowing Java applets</h3>

<p>To load an {{HTMLElement("applet")}} you must specify <code>application/x-java-applet</code>:</p>

<pre class="brush: bash">Content-Security-Policy: plugin-types application/x-java-applet</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{specName("CSP 3.0", "#directive-plugin-types", "plugin-types")}}</td>
   <td>{{Spec2('CSP 3.0')}}</td>
   <td>No changes.</td>
  </tr>
  <tr>
   <td>{{specName("CSP 1.1", "#directive-plugin-types", "plugin-types")}}</td>
   <td>{{Spec2('CSP 1.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.csp.Content-Security-Policy.plugin-types")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Content-Security-Policy")}}: {{CSP("object-src")}}</li>
 <li>{{HTMLElement("object")}}</li>
 <li>{{HTMLElement("embed")}}</li>
 <li>{{HTMLElement("applet")}}</li>
 <li>{{HTTPHeader("X-Content-Type-Options")}}</li>
</ul>
